const dd = console.log;

const App = {

  drawMode: null,
  
  init() {
    
    Controller.update();
    $('.timectrl').draggable({
      axis: 'x',
      containment: 'parent',
      drag() {
        $('.video-elem')[0].currentTime = DWchange($(this).position().left + 5, 'duration');
      },
      stop() {
        Video.canHandle = true;
        $('.video-elem')[0].play()
      }
    });

    App.hook();

  },

  
  hook() {

    $(document)
      .on('mousedown', '.timectrl', _ => {
        Video.canHandle = false;
        $('.video-elem')[0].pause()
      })
      .on('click', '.cover', function () {
        Video.play($(this).attr('data-path'));

        setTimeout(_ => {
          Clips.clips = [];
          Clips.addClip(0, $('.video-elem')[0].duration, 'vid');
          Controller.update();

          $('svg').html('vid');
        }, 100);
      })
      .on('click', '.btns button', function () {
        const elem_class = $(this).attr('class');

        switch (elem_class) {
          case "play": Video.resume(); break;
          case "stop": Video.pause(); break;
          case "remove-all": Clips.removeClip(Clips.clips.slice(1).map(v => v.id)); break;
          case "remove-sel": Clips.removeClip(Draw.selectedItem); break;
          case "download": Video.export(); break;
          case "merge": Clips.mergeClip(Draw.selectedItem); break;
          default:
            if (!$('.video-elem').attr('src').length) {
              return alert("먼저 영상을 선택하여 주세요.");
            }
            Draw.unselect();
            App.drawMode = $(this).attr('class');
            $('.btns button').removeClass('act-btn');
            $(this).addClass('act-btn');
        }
      })
      .on('mousedown mousemove mouseup mouseleave click', 'svg', Draw.drawEvent)
      .on('change', '.settings select', function () {
        Draw.selected[$(this).attr('id')] = $(this).val();
      })
      .on('click', '.act-btn', _ => {
        $('.act-btn').removeClass('act-btn');
        App.drawMode = null;
      })
      .on('input', '.text-inp', function () {

        const id = new Date().getTime();
        const ast = $(`<span id="a${id}">${
          $(this).val()
            .replaceAll("\n", "<br>​")
            // .replaceAll("\n", "<br>")
            .replaceAll(" ", "&nbsp;")
        }</span>`).css({
          'width': 'auto',
          'font-size': `${Draw.selected['font-size']}px`,
          'visibility': 'hidden'
        }).appendTo('body');
        
        $(this).css({
          'width': ast.outerWidth() + Draw.selected['font-size'] * 0.2,
          'height': ast.outerHeight()
        });
        $(this).parent().attr({
          'width': ast.outerWidth() + Draw.selected['font-size'] * 0.2,
          'height': ast.outerHeight()
        });

        $(`#a${id}`).remove();
        $(this).attr('data-val', $(this).val());

      })
      .on('blur', '.text-inp', function (e) {

        const className = $(this).parent().attr('class').split(" ")[0];
        if (!$(this).val().trim().length) {
          Draw.item = null;
          return $(`.${className}`).remove();
        }

        $(this).css({
          'border': 'none'
        }).attr({
          'readonly': "readonly",
          'disabled': "disabled",
          'unselectable': "on"
        }).css({
          'user-select': 'none',
          'z-index': '10'
        });

        $(this)
          .parent()
          .after()
          .css({
            'z-index': '11 !important'
          })
        
        const item = $(this).parent();
        Draw.draggable(item);

        Clips.addClip(0, $( '.video-elem')[0].duration, className);
        setTimeout(_ => Draw.item = null, 100);

      })
      .on('mousedown', '.text-inp', e => {
        dd(e.target);
        if ($(e.target).attr('class').includes('text-inp')) 
          e.preventDefault();
      })
      .on('click', '.clip-duration', function (e) {
        const clipObject = Clips.clips.find(v => v.id == $(this).parent().attr('data-id'));
        
        if (App.drawMode !== 'selection') return;
        
        if (!e.ctrlKey) {
          Draw.unselect();
        }
        if (Draw.selectedItem.includes(clipObject.id)) {
          if (e.ctrlKey) {
            Draw.unselectOnce(clipObject.childs[0]);
            return;
          }
        }
        
        Draw.select(clipObject.childs[0]);
      });
  }

};


const Draw = {
  path: [],
  selectedItem: [],
  item: null,
  move: [],


  selected: {
    'color': 'gray',
    'line-weight': '3',
    'font-size': '16'
  },


  drawEvent(e) {
    switch (e.type) {


      case 'mousedown':
        if ($(e.target).prop('tagName') !== 'svg') return;

        if (Draw.item) return;
        if (!App.drawMode || App.drawMode === 'text') return;
        if (App.drawMode === 'selection') {
          Draw.unselect();
          return;
        }

        if (!$('.video-elem').attr('src').length) return;

        const id = new Date().getTime();

        Draw.path.push([
          Math.round(e.pageX - $('.vid-main').offset().left),
          Math.round(e.pageY - $('.vid-main').offset().top)
        ]);
        Draw.item = svg();
        if (App.drawMode === 'curved-line') Draw.item = svg('polyline');
        else Draw.item.css('border', `2px solid ${Draw.selected.color}`);

        Draw.item.attr('class', `a${id} canAppendText`);
        $('svg').append(Draw.item)

        break;


      case 'mousemove':
        if (Draw.item && App.drawMode !== 'text') {

          Draw.path.push([
            Math.round(e.pageX - $('.vid-main').offset().left),
            Math.round(e.pageY - $('.vid-main').offset().top)
          ]);
          if (App.drawMode === 'curved-line') {
            Draw.item.attr('points', Draw.path.reduce((acc, v) => `${acc} ${v.join()}`, '').substring(1));
          } else {
            const [x, y] = Draw.path[0];
            const [nx, ny] = [...Draw.path].reverse()[0];
            $(Draw.item).attr({
              'x': Math.min(x, nx),
              'y': Math.min(y, ny),
              'width': Math.abs(nx - x),
              'height': Math.abs(ny - y)
            }).css('stroke', Draw.selected.color);
          }
        
        }
        break;

        
      case 'mouseup':
      case 'mouseleave':
        if (Draw.item && App.drawMode !== 'text') {
          if (e.type === 'mouseleave') $(Draw.item).remove();
          else {
            if (App.drawMode === 'square') 
              $(Draw.item).css({
                'border': 'none',
                'background': Draw.selected.color
              });

            Draw.draggable(Draw.item);
            Clips.addClip(0, $('.video-elem')[0].duration, $(Draw.item).attr('class').split(" ")[0]);
          }
          Draw.item = null;
          Draw.path = [];
        }

        if (
          e.type === 'mouseup' 
          && $(e.target).attr("class").includes("canAppendText")
          && App.drawMode === 'text' 
          && !Draw.item
        ) {
          const id = new Date().getTime();
          const [x, y] = [
            Math.round(e.pageX - $('.vid-main').offset().left),
            Math.round(e.pageY - $('.vid-main').offset().top)
          ];

          Draw.item = svg();
          Draw.item
            .css({
              'font-size': Draw.selected['font-size'],
              'color': Draw.selected['color'],
              'overflow': 'visible',
            })
            .attr({
              'class': `a${id}`,
              'x': x, 'y': y,
              'width': 1,
              'height': 1,
            })
            .append(`<textarea class="text-inp"></textarea>`)
            .find('.text-inp')
            .css({
              'width': 2,
              'height': `${Draw.selected['font-size'] * 1.2}px`,
              'font-family': 'initial',
              'font-size': `${Draw.selected['font-size']}px`,
              'color': Draw.selected['color'],
              'border': '2px solid #08f'
            })
            .draggable();

          $('svg').append(Draw.item);
          $(Draw.item).find('.text-inp').focus();

        }

        break;
    }
  },

  select(selectId) {
    const clipObject = Clips.clips.find(v => v.childs.includes(selectId));
    const clipId = clipObject.id;
    Draw.selectedItem.push(clipId);

    const startTime = Math.min(...[...Draw.selectedItem].map(v => Clips.clips.find(w => w.id == v).start));
    const endTime = Math.max(...[...Draw.selectedItem].map(v => Clips.clips.find(w => w.id == v).end));
    const duration = endTime - startTime;

    $('.start-time').html(`시작 시간: ${getTimeAsFormatted(startTime)}`);
    $('.duration')  .html(`유지 시간: ${getTimeAsFormatted(duration)}`);

    
    clipObject.childs.forEach(v => {
      if ($(`.${v}`).prop("tagName") === "textarea" || $(`.${v}`).find('textarea').toArray().length) {
        if ($(`.${v}`).prop("tagName") === 'textarea') return;
        $(`.${v}`).css({
          'outline': '3px solid #6fbecf'
        });
        
        return;
      }
  
  
      $(`.${v}`).css({
        'filter': `
          drop-shadow(3px 0 0 #6fbecf) drop-shadow(-3px 0 0 #6fbecf) drop-shadow(0 3px 0 #6fbecf) drop-shadow(0 -3px 0 #6fbecf)
        `
      });
    });

    
    $('._clip').each((_, elem) => {
      if (clipId == $(elem).attr('data-id')) {
        $(elem).find('.clip-duration').css({
          'background': '#6fbecf'
        })
      }
    });
  },

  draggable(item) {
    $(item)
      .draggable()
      .on('mousedown', function (e) {
        const cId = $(this).attr('class').split(" ")[0];
        const clipId = Clips.clips.find(v => v.childs.includes(cId)).id;

        dd(e.ctrlKey, Draw.selectedItem.includes(clipId));

        if (!e.ctrlKey && App.drawMode === 'selection') {
          Draw.unselect();
        }
        if (Draw.selectedItem.includes(clipId) && App.drawMode === 'selection') {
          if (e.ctrlKey) {
            Draw.unselectOnce(cId);
            return;
          }
        }
        if (App.drawMode === 'selection') Draw.select(cId);

        if (Draw.move.length || !Draw.selectedItem) return; 
        
        Draw.move = [e.pageX - $('svg').offset().left, e.pageY - $('svg').offset().top];
        dd(Draw.move);
      })
      .on('drag', function (e) {
        if (!Draw.selectedItem || App.drawMode !== 'selection') return;
        if (!Draw.move.length) return; 

        const [moveStartX, moveStartY] = Draw.move;
        const [mouseX, mouseY] = [e.pageX - $('svg').offset().left, e.pageY - $('svg').offset().top];
        const [movedX, movedY] = [mouseX - moveStartX, mouseY - moveStartY];

        const cId = $(this).attr('class').split(" ")[0];

        dd(moveStartX, moveStartY, movedX, movedY);

        const clipObject = Clips.clips.find(v => v.childs.includes(cId));
        clipObject.childs.forEach(elem => {

          elem = `.${elem}`;
          
          switch ($(elem).prop('tagName')) {
            case "polyline":
              if (!$(elem).attr('data-prevs')) {
                $(elem).attr('data-prevs', $(elem).attr('points'));
              }
              
              let points = $(elem).attr('data-prevs').split(" ");

              const updatedPoints = points.map(v => {
                const [pointX, pointY] = v.split(",");
                const [lastX, lastY] = [pointX * 1 + movedX, pointY * 1 + movedY];

                return `${lastX},${lastY}`;
              }).join(" ");

              $(elem).attr('points', updatedPoints);
              break;
            default:
              if (!$(elem).attr('data-prev-x') || !$(elem).attr('data-prev-y')) {
                $(elem).attr('data-prev-x', $(elem).attr('x'));
                $(elem).attr('data-prev-y', $(elem).attr('y'));
              }

              $(elem).css({
                'top': '0',
                'left': '0'
              }).attr({
                'x': $(elem).attr('data-prev-x') * 1 + movedX,
                'y': $(elem).attr('data-prev-y') * 1 + movedY
              });
          }

        });
      })
      .on('mouseup', function (e) {
        const cId = $(this).attr('class').split(" ")[0];
        const clipObject = Clips.clips.find(v => v.childs.includes(cId));

        if (!Draw.selectedItem || App.drawMode !== 'selection') return;
        if (!Draw.move.length) return;


        clipObject.childs.forEach(elem => {
          elem = `.${elem}`;
          if ($(elem).attr('data-prevs')) { // polyline
            $(elem).attr('data-prevs', $(elem).attr('points'));
          }
          if ($(elem).attr('data-prev-x') || $(elem).attr('data-prev-y')) { // square, text
            $(elem).attr({
              'data-prev-x': $(elem).attr('x'),
              'data-prev-y': $(elem).attr('y')
            });
          }
        });

        Draw.move = [];
      });
  },

  unselect() {
    Draw.selectedItem = [];
    $(`svg *`).css({'filter': 'none', 'outline': 'none'});
    $('.clip-duration').css('background', '#ccc');
  },
  
  unselectOnce(unselectId) {
    const clipObject = Clips.clips.find(v => v.childs.includes(unselectId));
    const clipId = clipObject.id;
    
    Draw.selectedItem.splice(
      Draw.selectedItem.findIndex(v => v == clipId),
      1
    );
      
    clipObject.childs.forEach(v => {
      $(`.${v}`).css({'filter': 'none', 'outline': 'none'})
    });

    $('._clip').each((_, v) => {
      if ($(v).attr('data-id') == clipId) {
        $(v).find('.clip-duration').css('background', '#ccc');
      }
    });
  }
};


const Video = {

  canHandle: true,

  play(resourcePath) {
    $('.video-elem').attr('src', resourcePath)[0].play();
  },

  resume() {
    if ($('.video-elem').attr('src').length) {
      $('.video-elem')[0].play();
    }
  },
  pause() {
    $('.video-elem')[0].pause();
  },


  updateTimeline() {
    if (!Video.canHandle) return;

    const currentTime = $('.video-elem')[0].currentTime;
    const length = $('.video-elem')[0].duration;

    $('.current').html(getTimeAsFormatted(currentTime));
    $('.length').html(getTimeAsFormatted(length));
    $('.timectrl').css('left', DWchange($('.video-elem')[0].currentTime, 'width') - 5);

    Clips.clips.forEach(v => v.showClips(
      $('.video-elem')[0].currentTime
    ));
  },


  async export() {
    let html = await $.get("/video.html");
    const clip = [...Clips.clips];
    const objectClip = clip.map(v => {
      return {
        "id": v.id,
        "childs": v.childs,
        "start": v.start,
        "end": v.end
      };
    });
    
    html = html.replace(`<div class="script" style="display: none">`, `
    
      <div class="script" style="display: none">
        $('video').attr('src', 'http://localhost/${$('video').attr('src')}');
        $('svg').html(\`${$('svg').html()}\`);
        Clips.clips = JSON.parse('${JSON.stringify(objectClip)}').map(function (v) {
          return Clips.getClipsFromObject(v);
        });

        $('textarea').each(function (i, v) {
          $(v).val($(v).attr('data-val'));
        });

    `);

    const blob = new Blob([html, {type:'text/html'}]);
    const downloadURL = window.URL.createObjectURL(blob);
    const aTag = document.createElement("a");
    
    aTag.href = downloadURL;
    aTag.download = `video.html`;
    aTag.click();
    aTag.remove();

    window.URL.revokeObjectURL(downloadURL);
    
  }

};


const Clips = {
  clips: [],
  
  addClip(start, end, elem) {
    const id = new Date().getTime();
    const clip = new Clip(id);
    clip.addElement(elem);
    clip.editLengths(start, end);

    Clips.clips.push(clip);
    Controller.update();
  },
  mergeClip(clipIds) {
    const clips = clipIds.map(v => Clips.clips.find(w => w.id === v));
    const startTime = clips.sort((a, b) => a.start - b.start)[0].start;
    const endTime = clips.sort((a, b) => b.end - a.end)[0].end;
    const childs = clips.reduce((acc, v) => [...acc, ...v.childs], []);
    
    Clips.clips = Clips.clips.filter(v => !clipIds.includes(v.id));


    const mergedClip = new Clip(new Date().getTime());
    mergedClip.start = startTime;
    mergedClip.end = endTime;
    mergedClip.childs = childs;


    Clips.clips.push(mergedClip);
    Draw.unselect();


    Controller.update();
  },
  findClipByElementId(elementId) {
    return Clips.clips.find(v => v.childs.includes(elementId.replaceAll("a", '')));
  },
  removeClip(clips) {
    clips.forEach(clipId => {
      const clipIndex = Clips.clips.findIndex(v => v.id === clipId);
      Clips.clips[clipIndex].childs.forEach(v => $(`.${v}`).remove());
      Clips.clips.splice(clipIndex, 1);
    });
    
    Draw.unselect();
    Controller.update();
  }
}


const Controller = {

  update() {
    Controller[Clips.clips.length ? 'show' : 'hide']();
    $('.timeline')
      .html(
        [...Clips.clips].reverse().map(v => `
          <div class='_clip' data-id="${v.id}">
            <div class="clip-duration"></div>
          </div>
        `)
      )
      .sortable({
        axis: 'y',
        stop() {
          let childs = $(this).children().toArray().reverse();
          const html = childs.reduce((acc, v) => {
            const id = $(v).attr('data-id');
            const clip = Clips.clips.find(w => w.id == id);
            const clipChilds = clip.childs;
            const clipHtml = clipChilds.reduce((h, w) => {
              try {
                const elementHtml = $(`.${w}`)[0].outerHTML;
                return h + elementHtml;
              } catch (e) {
                return h;
              }
            }, "");

            return acc + clipHtml;
          }, "");

          $('svg').html(html);
          $('svg').children().toArray().forEach(v => {
            const children = $(v);
            Draw.draggable(children);
          });
          $('textarea').each((i, v) => $(v).val($(v).attr('data-val')));
        }
      })
      .find('.clip-duration')
      .each(function (_, elem) {
        const clip = Clips.clips.find(v => v.id == $(elem).parent().attr('data-id'));

        $(elem).css({
          left: DWchange(clip.start, 'width'),
          width: DWchange(clip.end - clip.start, 'width')
        });
      })
      .resizable({
        handles: 'e,w',
        maxWidth: 1080,
        minWidth: 0,
        maxHeight: 20,
        minHeight: 20,
        stop() {
          let $class = $(this).parent().attr('data-id');
          let start = DWchange($(this).position().left, 'duration');
          let end = DWchange($(this).position().left + $(this).outerWidth(), 'duration');

          const clipIndex = Clips.clips.findIndex(v => v.id == $class);
          Clips.clips[clipIndex].editLengths(start, end);

          if (Draw.selectedItem.includes(Clips.clips[clipIndex].id)) {
            const selected = [...Draw.selectedItem];
            const startTime = Math.min(...selected.map(v => Clips.clips.find(w => w.id == v).start));
            const endTime = Math.max(...selected.map(v => Clips.clips.find(w => w.id == v).end));
            const duration = endTime - startTime;

            $('.start-time').html(`시작 시간: ${getTimeAsFormatted(startTime)}`);
            $('.duration')  .html(`유지 시간: ${getTimeAsFormatted(duration)}`);
          }
        }
      })
      .draggable({
        containment: 'parent',
        stop() {
          let $class = $(this).parent().attr('data-id');
          let start = DWchange($(this).position().left, 'duration');
          let end = DWchange($(this).position().left + $(this).outerWidth(), 'duration');

          const clipIndex = Clips.clips.findIndex(v => v.id == $class);
          Clips.clips[clipIndex].editLengths(start, end);

          if (Draw.selectedItem.includes(Clips.clips[clipIndex].id)) {
            $('.start-time').html(`시작 시간: ${getTimeAsFormatted(start)}`);
            $('.duration')  .html(`유지 시간: ${getTimeAsFormatted(end - start)}`);
          }
        }
      });

  },

  show() {$('.controller').show()},
  hide() {$('.controller').hide()}

};



// sec. to formatted time string(hh:mm:ss:dd).
function getTimeAsFormatted(time) {
  time *= 1;
  const dot = `${time}`.split(".").length === 2
    ? `${time}`.split(".")[1].slice(0, 2)
   :'00';
  let sec = `${Math.floor(time % 60)}`.padStart(2, 0);
  let min = `${Math.floor((time / 60) % 60)}`.padStart(2, 0);
  let hur = `${Math.floor((time / (60 * 60)))}`.padStart(2, 0);

  if (isNaN(sec)) sec = '00';
  if (isNaN(min)) min = '00';
  if (isNaN(hur)) hur = '00';

  return `${hur}:${min}:${sec}:${dot}`;
}


// convert to svg
function svg(type = 'foreignObject') {
  const elm = $(document.createElementNS('http://www.w3.org/2000/svg', type)).css({
      color: Draw.selected['color'],
      fontSize: Draw.selected['font-size'],
      strokeWidth: Draw.selected['line-weight'],
      fill: 'none',
      strokeLinejoin: 'round',
      strokeLinecap: 'round',
      stroke: Draw.selected['color'],
    })

  return elm;
}


// get width from duration
function DWchange(data, type) {
  return {
    width: $('.controller').outerWidth() / $('.video-elem')[0].duration * data,
    duration: $('.video-elem')[0].duration * (data / $('.controller').outerWidth())
  }[type];
}



class Clip {
  id = null; childs = []; start = null; end = null;
  constructor(id) {this.id = id;}
  addElement(clipId) {this.childs.push(clipId);}
  editLengths(start, end) {[this.start, this.end] = [start, end];}
  showClips(nowTime) {
    if (this.start <= nowTime && nowTime <= this.end) {
      this.childs.forEach(v => {
        $(`.${v}`).css('display', 'block');
      });
    } else {
      this.childs.forEach(v => {
        $(`.${v}`).css('display', 'none');
      })
    }
  }
}


// $(_ => setTimeout(_ => App.init(), 500));
$(_ => App.init())